from nosuch.midiutil import *
from traceback import format_exc
from time import sleep

if __name__ == '__main__':

	Midi.startup()

	a = MidiInput.devices()
	for nm in a:
		print "Opening input = ",nm
		MidiInput(nm).open()

	def print_midi(msg,data):
		print("MIDI = %s" % str(msg))

	Midi.callback(print_midi,"dummy")

	try:
		while True:
			sleep(1.0)
	except KeyboardInterrupt:
		print "Got KeyboardInterrupt!"
	except:
		print "Unexpected exception: %s" % format_exc()

	Midi.shutdown()

	print "End of midimon.py"
